<?php
/*
 * Purpose:  Escape the string according to escapement type
 *
 * Code from Smarty: http://smarty.php.net/
 * Smarty is avalible under LGPL: smarty.license.txt
 *
 */

function plugin_escape($string, $esc_type = 'html') {
	switch ($esc_type) {
		case 'html': 		return htmlspecialchars($string, ENT_QUOTES);
		case 'htmlall':		return htmlentities($string, ENT_QUOTES);
		case 'url':		return urlencode($string);
					// escape unescaped single quotes
		case 'quotes': 		return preg_replace("%(?<!\\\\)'%", "\\'", $string);
					// escape quotes and backslashes and newlines
		case 'javascript':	return strtr($string, array('\\'=>'\\\\',"'"=>"\\'",'"'=>'\\"',"\r"=>'\\r',"\n"=>'\\n'));
					// escape every character into hex
		case 'hex': 
			$return = '';
			for ($x=0; $x < strlen($string); $x++) {
				$return .= '%' . bin2hex($string[$x]);
			}
			return $return;
		case 'hexentity':
			$return = '';
			for ($x=0; $x < strlen($string); $x++) {
				$return .= '&#x' . bin2hex($string[$x]) . ';';
			}
			return $return;

		default:
			trigger_error( 'Undefined escape type', E_USER_NOTICE );
			return $string;
	}
}
?>
